/* ---------------------------------------------------------- */
/*  pen_demo1.h                                               */
/* ---------------------------------------------------------- */

/*--------------------------------------------------------*/
/*                                                        */
/* GP2X-F200 Pen demo                                     */
/*                        Fumi2Kick                       */
/*                        1st Maintaner  rerofumi.        */
/*                                                        */
/*   pen_demo1.h                                          */
/*     ѥͥ뤺ꤺǥ                                 */
/*                                                        */
/*--------------------------------------------------------*/

#ifndef PEN_DEMO1_H
#define PEN_DEMO1_H

/*-------------------------------*/
/* include                       */
/*-------------------------------*/

#include "input.h"
#include "sound.h"
#include "debug.h"
#include "grp_screen.h"

/*-------------------------------*/
/* define                        */
/*-------------------------------*/

#ifndef TRUE
#define TRUE 1
#endif

#ifndef FALSE
#define FALSE 0
#endif


/*-------------------------------*/
/* struct                        */
/*-------------------------------*/

/*-------------------------------*/
/* class                         */
/*-------------------------------*/

/**
 * @brief touchpanel demo 1
 *        game main routine
 *
 * @todo -
 * @bug -
 */
class CPenDemo1
{
  //! ¹Ծ
  enum {
    STAT_NONE = 0,
    STAT_EXEC,
    STAT_DONE
  } EXECSTATE;
  
  //! ʹԥƥå
  enum {
    STEP_INIT = 0,
    STEP_TITLE_INIT,
    STEP_TITLE_MAIN,
    STEP_TITLE_END,
    STEP_GAME_INIT,
    STEP_GAME_MAIN
  } GAMESTEP;

  /* ----------------------------------- */
  /* --- 󥹥ȥ饯ǥȥ饯 */
 public:
  CPenDemo1(TGameScreen *mainscreen);
  virtual  ~CPenDemo1();

  /* ----------------------------------- */
  /* --- public member */
 public:

  /* ----------------------------------- */
  /* --- private member */
 private:
  //! ̴饹
  TGameScreen  *m_screen;
  //! ʹԾ
  int m_stat;
  //! ॹƥå
  int m_step;
  //! ॹץ饤
  TGameSprite  *m_spr_screen;
  TGameSprite  *m_spr_picture;
  /* ---  */
  int  m_pic_x, m_pic_y;
  float  m_pic_rot;
  int  m_drag_pos_x, m_drag_pos_y;
  float  m_drag_angle;
  float  m_drag_length;
  int  m_drag_sw;


  /* ----------------------------------- */
  /* --- public method */
 public:
  //! ̴饹Ϥ
  void setScreen(TGameScreen *mainscreen);
  //! Υꥻå
  void onReset(void);
  //! ¹Ծ֤
  int  stat(void);
  //! ե졼κ
  int  onTick(void);
  //! ꥯ
  void  onDraw(void);

  /* ----------------------------------- */
  /* --- private method */
 private:
  int  on_tick(void);

};


#endif //PEN_DEMO1_H
